Description

#37674 changed the /users endpoint behavior by dropping support for the previously supported status and name URL parameters.

This might break API clients that relied on these parameters. Further the functionality of the 'Name' filter, which allowed to do a

combined search across users' name, email and login was lost for both API and Browser clients.

The attached patch that's been extracted from Planio introduces a new 'Name, email or login' query filter and maps the legacy 'name'

URL parameter to this new filter. Also, a 'status' URL parameter will be mapped to a query on 'status_id' if present.

Related issues:

Related to Redmine - Feature #37674: Upgrade Admin/Users list to use the quer... Closed

Related to Redmine - Defect #38165: Users API ignores name and group_id param... Closed

Associated revisions

Revision 22343 - 2023-10-15 03:42 - Go MAEDA

API compatibility to legacy status and name query params (#39181, #37674)

- adds 'name' filter that mimics the old behavior of matching on email, login, first- or lastname

- maps the 'status' url parameter to the status_id filter, and the 'name' url parameter to the new name filter

Patch by Jens Krämer.

Revision 22344 - 2023-10-15 03:44 - Go MAEDA

Update locales (#39181, #37674).

Revision 22346 - 2023-10-16 16:17 - Go MAEDA

Fix RuboCop offenses due to r22343: Style/RedundantRegexpEscape, Layout/EmptyLinesAroundMethodBody, and Style/HashSyntax (#39181).

Revision 22354 - 2023-10-17 11:27 - Go MAEDA

Fix comment to correctly represent legacy filter parameters handling in UsersController#index API requests (#39181).

Patch by Mischa The Evil.

History

#1 - 2023-10-11 12:21 - Holger Just

- Description updated

#2 - 2023-10-11 14:03 - Holger Just

- Related to Feature #37674: Upgrade Admin/Users list to use the query system added

#3 - 2023-10-12 04:21 - Mischa The Evil

- Description updated

Jens Krämer wrote:

#37674 changed the /users endpoint behavior by dropping support for the previously supported status and name URL parameters. This might

break API clients that relied on these parameters. Further the functionality of the 'Name' filter, which allowed to do a combined search across

users' name, email and login was lost for both API and Browser clients.

 Tentatively confirmed (by code review only).

2025-05-01 1/3

https://www.redmine.org/issues/37674
https://plan.io/redmine-hosting
https://www.redmine.org/issues/37674


Besides the previously supported status and name URL parameters, Redmine also supported a group_id URL parameter (per #7893), which allowed

clients to "get only users who are members of the given group

1

".

AFAICT this functionality got lost with the implementation of #37674 too.

Extending the attached patch like this (untested code):

diff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb

index 77ec1a601..e1d3a7521 100644

--- a/app/controllers/users_controller.rb

+++ b/app/controllers/users_controller.rb

@@ -45,6 +45,20 @@ class UsersController < ApplicationController

     use_session = !request.format.csv?

     retrieve_query(UserQuery, use_session)

+    # API backwards compatibility: handle legacy status, name and

+    # group_id filter parameters

+    unless request.format.html?

+      if status_id = params[:status].presence

+        @query.add_filter 'status', '=', [status_id]

+      end

+      if name = params[:name].presence

+        @query.add_filter 'name', '~', [name]

+      end

+      if group_id = params[:group_id].presence

+        @query.add_filter 'is_member_of_group', '=', [group_id]

+      end

+    end

+

     if @query.valid?

       scope = @query.results_scope

 would probably suffice to fix this additional API compatibility regression.

It should additionally map the 'group_id' URL parameter to a query on 'is_member_of_group' if present.

I think that it would also be good to have some test coverage for these API features in case this patch (with or without my extension) is accepted.
 from Rest_Users#GET

#4 - 2023-10-13 05:15 - Jens Krämer

- File 0001-API-compatibility-to-legacy-status-and-name-query-pa.patch added

thanks for looking into this, and yes, adding group_id as well seems right to me. I attached a revised patch including this as well as an integration test

covering this.

#5 - 2023-10-15 03:44 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the fix as a part of #37674. Thank you.

#6 - 2023-10-15 04:55 - Mischa The Evil

- Status changed from Closed to Reopened

Go MAEDA wrote in #note-5:

Committed the fix as a part of #37674. Thank you.

 Go MAEDA: for sake of correctness, can you also adapt the comment to actually reflect the current situation like something I proposed in #note-3?

#7 - 2023-10-16 16:12 - Go MAEDA

Mischa The Evil wrote in #note-6:

Go MAEDA: for sake of correctness, can you also adapt the comment to actually reflect the current situation like something I proposed in 

#note-3?

 Thank you for reviewing the commits. Am I correct that you are saying that the following change should also be committed?

2025-05-01 2/3

https://www.redmine.org/issues/7893
https://www.redmine.org/issues/37674
https://www.redmine.org/projects/redmine/wiki/Rest_Users#GET
https://www.redmine.org/issues/37674
https://www.redmine.org/issues/37674
https://www.redmine.org/users/332
https://www.redmine.org/users/332


diff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb

index f64c469da..cd430dc32 100644

--- a/app/controllers/users_controller.rb

+++ b/app/controllers/users_controller.rb

@@ -45,7 +45,8 @@ class UsersController < ApplicationController

     use_session = !request.format.csv?

     retrieve_query(UserQuery, use_session)

-    # API backwards compatibility: handle legacy status and name filter parameters

+    # API backwards compatibility: handle legacy status and name and

+    # group_id filter parameters

     unless request.format.html?

       if status_id = params[:status].presence

         @query.add_filter 'status', '=', [status_id]

#8 - 2023-10-17 01:47 - Mischa The Evil

Go MAEDA wrote in #note-7:

Mischa The Evil wrote in #note-6:

Go MAEDA: for sake of correctness, can you also adapt the comment to actually reflect the current situation like something I proposed in 

#note-3?

 Thank you for reviewing the commits. Am I correct that you are saying that the following change should also be committed?

[...]

 Yes, although I prefer the punctuation I proposed in #note-3. Nevertheless, something more general like the following might be fine (or even better)

too:

diff --git a/app/controllers/users_controller.rb b/app/controllers/users_controller.rb

index f64c469da..cd430dc32 100644

--- a/app/controllers/users_controller.rb

+++ b/app/controllers/users_controller.rb

@@ -45,7 +45,8 @@ class UsersController < ApplicationController

     use_session = !request.format.csv?

     retrieve_query(UserQuery, use_session)

-    # API backwards compatibility: handle legacy status and name filter parameters

+    # API backwards compatibility: handle legacy filter parameters

     unless request.format.html?

       if status_id = params[:status].presence

         @query.add_filter 'status', '=', [status_id]

 Off-topic: it seems Rouge's diff lexer is affected by a bug that handles code comments wrongly...

#9 - 2023-10-17 11:29 - Go MAEDA

- Status changed from Reopened to Closed

Fixed the comment in r22354, as Mischa suggested in #note-8. Thank you.

#10 - 2023-10-18 00:04 - Mischa The Evil

Thanks. Also thanks to Jens and the Plan crew for sharing this work.

#11 - 2023-12-28 08:59 - Go MAEDA

- Related to Defect #38165: Users API ignores name and group_id parameter added

Files

0001-API-compatibility-to-legacy-status-and-name-query-pa.patch 4.76 KB 2023-10-11 Jens Krämer

0001-API-compatibility-to-legacy-status-and-name-query-pa.patch 6.95 KB 2023-10-13 Jens Krämer
